Java-异常

Java异常是Java提供的用于处理程序中错误的一种机制。所谓错误是指在程序运行的过程中发生的一些异常事件(如:除0溢出,数组下标越界,所要读取的文件不存在)**并非在编写代码出现的编译时错误(注意:发生异常时,观察错误的名字和行号最重要),设计良好的程序应该在异常发生时提供处理这些错误的方法,使得程序不会因为异常的发生而阻断或产生不可遇见的结果。

Java程序的执行过程中如果出现异常事件,可以生成一个异常类对象,该异常对象封装了异常事件的信息并被提交给Java运行时系统,这个过程称为抛出(throw)异常。当Java运行时系统接收到异常对象时,会寻找能处理这一异常的代码并把当前异常对象交给其处理,这一过程称为捕获(catch)异常。

public class TestEx{
    public static void (String[] args){
        int[] arr = {1,2,3};
        System.out.println("arr[2]");
        try{
            System.out.println(2/0);
        }catch(ArithmeticException e){ // 捕获异常并在代码块中处理,e是为异常命名,因为生成异常的后会生成一个异常的对象
            System.out.println("出错了。。。")
            e.printStackTrace(); // 把错误的堆栈信息打出来
        }
    }
}

再看一个例子

public void someMethod() throws SomeException{ // 在方法后面定义异常,在使用时要注意此异常
    if(someCondition()){
        throw new SomeException("错误原因") // 构造并抛出异常对象
    }
}

异常的分类

Error:称为错误,由Java虚拟机生成并抛出,包括动态连接失败、虚拟机错误等,程序对其不做处理 Exception:所有异常类的父类,其子类对应了各种各样可能出现的异常,一般需要用户显式的声明或捕获 RuntimeException :一类特殊的异常,如被0除,数组下标超范围等,其产生比较频繁,处理麻烦,如果显式的声明或捕获将会将会程序可读性和运行效率影响很大。因此由系统自动检测并将它们交给缺省的异常处理程序(用户可不必对其处理) 除了RuntimeException的Exception:必须catch ,在JDK里写了throw的必须的catch

Exception(in java.lang)
    ClassNotFoundException
    IOException
    InterruptedException
    RuntimeException
        ArithmeticException NullPointerException
        IndexOutOfBoundsException
          ArrayIndexOutObBoundsException
          StringIndexOutBoundsException

异常的捕获和处理

try 语句块中有多个语句时,执行到某个语句产生异常时,此时这个try 语句块中其他的语句不再执行,直接到对应的catch语句,最后finally语句;如果代码块中有多个try语句时,一个try执行时catch到异常,另一个try还会继续执行;如果一个try语句中没有捕获异常也要走finally语句

也可以不写trycatch 直接throws在方法抛出异常,当别人调这个方法的时候处理,别人也可以选择不处理继续throws在方法抛出异常,main()方法也可以想向上抛出交给java运行时系统处理

try{...}语句指定了一段代码,该段代码就是一次捕获并处理异常的范围,在执行过程中,该段代码可能会产生并抛出一种或几种类型的异常对象。它后面的catch语句要分别对这些异常做相应的处理,如果没有的catch代码都会被略过不执行

在catch语句中时对异常进行处理的代码,每个try语句块可以伴随一个或多个catch语句,用于处理可能产生的不同类型的异常对象。在catch中声明的异常对象封装了异常事件发生的信息,在catch语句块中可以使用和这个对象一些方法获取这些信息。

getMessage() 用来得到有关异常事件的信息
printStackTrace() 用来跟踪异常事件发生时执行堆栈的内容

finally语句为异常处理提供一个统一的出口,使得在控制流程转到程序的其他部分以前,能够对程序的状态作统一的管理。无论try所指定的程序块中是否抛出异常,finally所指定的代码都要被执行。通常在finally语句中可以进行资源的清除工作。如:关闭打开的文件,删除临时文件

public class Test01 {
    public static void main(String[] args) {
        Testyichang  testyichang = new Testyichang();
        try {
            testyichang.method1();
        } catch (Exception e) {
            System.out.println("uuuuuuuu");
        }
    }
    public void method1() throws Exception{
        method2();
    }
    public void method2() throws Exception{
        method3();
    }
    public void method3() throws Exception{
    }
}
// 执行结果
uuuuuuuu
public class Testyichang {
    public static void main(String[] args) {
        Testyichang  testyichang = new Testyichang();
        try {
            testyichang.method1();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    public void method1() throws Exception{
        method2();
    }
    public void method2() throws Exception{ 
        method3();
    }
    public void method3() throws Exception{
        throw new Exception("hhhh");
    }
}
// 指定结果
java.lang.Exception: hhhh
    at com.sangyu.Testyichang.method3(Testyichang.java:19)
    at com.sangyu.Testyichang.method2(Testyichang.java:16)
    at com.sangyu.Testyichang.method1(Testyichang.java:13)
    at com.sangyu.Testyichang.main(Testyichang.java:7)

使用自定义异常一般有如下步骤: 1)通过继承java.lang.Exception 类声明自己的异常类 2)在方法适当的位置生成自定义异常的实例,并用throw语句抛出 3)在方法的声明部分用throws语句声明该方法可能抛出的异常

public class Test03 {
    public void regist(int num) throws Exception {
        if (num < 0) {
            throw new MyException("人数为负值,不合理", 3); // throw 后面的语句不会再执行了
        }
        System.out.println("登记人数" + num);
    }

    public void manager() {
        try {
            regist(-1);
        } catch (MyException e) {
            System.out.println("登记失败,出错类型码 = " + e.getNum());
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println("操作结束");
    }

    public static void main(String[] args) {
        Test03 test03 = new Test03();
        test03.manager();
    }
}

class MyException extends Exception {

    int num;
    public MyException(String message, int num) {
        super(message);
        this.num = num;
    }

    public int getNum(){
        return num;
    }
}
// 执行结果:
登记失败,出错类型码 = 3
操作结束
com.sangyu.MyException: 人数为负值,不合理
    at com.sangyu.Test03.regist(Test03.java:6)
    at com.sangyu.Test03.manager(Test03.java:13)
    at com.sangyu.Test03.main(Test03.java:25)

本文参与腾讯云自媒体分享计划,欢迎正在阅读的你也加入,一起分享。

我来说两句

0 条评论
登录 后参与评论

相关文章

  • JDBC 使用DBUtils 查询、更新(15)

    commons-dbutils是Apache组织提供的一个开源JDBC工具类库,它是对JDBC的简单封装。简化了jdbc编码的工作量

    桑鱼
  • spring - 生命周期

    1)通过构造器或工厂方法创建Bean实例 2)为Bean的属性设置值和对其他Bean的引用 3)调用Bean的初始化方法 4)Bean可以使用了 5)当...

    桑鱼
  • 扩展和全面接管SpringMVC

    桑鱼
  • 【译】11条Java异常处理的最佳实践

    在之前关于Java异常的文章中,已经探讨过suppressed exceptions和Java Exceptions Tutorial 两个方面的内容。要想在...

    阿杜
  • Java异常 知识点速查

    linxinzhe
  • 服务端性能优化之异步查询转同步

    之前写过一篇文章分享了我在工作中遇到了一个因为性能优化出现的一个BUG:异步查询转同步加redis业务实现的BUG分享。

    八音弦
  • 腾讯安全联合实验室亮相“云+未来”峰会 ,腾讯云加入云安全联盟(CSA)

    腾讯云安全
  • java练习本(2019-06-14)

    “Life is not a problem to be solved, but a reality to be experienced.”

    微笑的小小刀
  • 6:异常处理

    六月的雨
  • Android LiveData 使用详解

    本次推出 Android Architecture Components 系列文章,目前写好了四篇,主要是关于 lifecycle,livedata 的使用和...

    用户2965908

扫码关注云+社区

领取腾讯云代金券